/**
 * Copyright (C) 2006-2019 INRIA and contributors
 *
 * Spoon is available either under the terms of the MIT License (see LICENSE-MIT.txt) of the Cecill-C License (see LICENSE-CECILL-C.txt). You as the user are entitled to choose the terms under which to adopt Spoon.
 */
package spoon.compiler.builder;

public class AdvancedOptions<T extends AdvancedOptions<T>> extends Options<T> {
	public AdvancedOptions() {
		super(AdvancedOptions.class);
	}

	public T continueExecution() {
		args.add("-noExit");
		return myself;
	}

	public T enableJavadoc() {
		args.add("-enableJavadoc");
		return myself;
	}

	public T preserveUnusedVars() {
		args.add("-preserveAllLocals");
		return myself;
	}
}
